#include <windows.h>
#include "CGm32.h"

#pragma comment(lib, "CGm32.lib")

#define MYWNDCLASS		TEXT("CLASS_CGm32Test")
#define MYWNDTITLE		TEXT("CGm32Test")

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

int WINAPI _tWinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPTSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static CBm32	bm1,bm2,bm3;
	static CGm32	gm1;
	
	switch (uMsg)
	{
	case WM_CREATE:
		bm1.Create(512, 512);
		bm2.Create(TEXT("map0_bk.bmp"));
		bm3.Create(TEXT("map0_ly.bmp"));
		bm3.SetColorKey(255, 0, 255);
		gm1.SetMapViewSize(14, 10);
		gm1.LoadMapData(TEXT("map0.bin"));
		return 0;
	case WM_PAINT:
		{
			HDC 		hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			bm1.DrawColor(255, 255, 255, 0);
			gm1.DrawMap(bm1, bm2, bm3);
			gm1.DrawPriorityMap(bm1, bm3);
			gm1.DrawHitJudge(bm1);
			bm1.DrawDC(hDC, 0, 0, 0, 0, bm1.GetWidth(), bm1.GetHeight());
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

