#ifndef __CBM32_H__
#define __CBM32_H__

#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <tchar.h>

#pragma comment(lib,"msimg32.lib")

#define DECLSPEC __declspec( dllexport )

class DECLSPEC CBm32
{
public:
	CBm32();
	void	Create(int width, int height);
	BOOL	Create(TCHAR *filename, int x = 0, int y = 0, int width = 0, int height = 0);
	BOOL	Delete();
	int		GetWidth(){return m_nWidth;}
	int		GetHeight(){return m_nHeight;}
	int		GetBPP(){return m_nBPP;}
	void	SetColorKeyFlag(BOOL flag){m_bColorkey = flag;}
	void	SetColorKey(BYTE red, BYTE green, BYTE blue){m_nColorkey = RGB(red, green, blue);
														m_bColorkey = TRUE;}
	BOOL	GetColorKeyFlag(){return m_bColorkey;}
	UINT	GetColorKey(){return m_nColorkey;}
	PBYTE	GetBits(){return m_pBits;}	// ߂l PBYTE   ͉Ȃ
	HBITMAP	GetHBmp(){return m_hBmp;}	// ߂l HBITMAP ͉Ȃ
	PTCHAR	GetFilename(){return m_strFilename;}
	BOOL	Reload(TCHAR *filename, int x = 0, int y = 0, int width = 0, int height = 0);
	BOOL	Draw(CBm32 &bm32, int xDst, int yDst, int xSrc = 0, int ySrc = 0,
						int width = 0, int height = 0);
	BOOL	DrawDC(HDC hDC, int xDst, int yDst, int xSrc = 0, int ySrc = 0,
						int width = 0, int height = 0);
	BOOL	DrawEx(CBm32 &bm32, int xDst, int yDst, int widthDst, int heightDst,
						int xSrc = 0, int ySrc = 0, int widthSrc = 0, int heightSrc = 0);
	BOOL	DrawKey(CBm32 &bm32, int xDst, int yDst, int xSrc, int ySrc,
						int width, int height);
	BOOL	DrawKeyDC(HDC hDC, int xDst, int yDst, int xSrc, int ySrc,
						int width, int height);
	BOOL	DrawKeyEx(CBm32 &bm32, int xDst, int yDst, int widthDst, int heightDst,
						int xSrc, int ySrc, int widthSrc, int heightSrc);
	BOOL	DrawAlpha(CBm32 &bm32, int xDst, int yDst, int xSrc, int ySrc,
						int width, int height, BYTE alpha);
	BOOL	DrawAlphaDC(HDC hDC, int xDst, int yDst, int xSrc, int ySrc,
						int width, int height, BYTE alpha);
	BOOL	DrawAlphaEx(CBm32 &bm32, int xDst, int yDst, int widthDst, int heightDst,
						int xSrc, int ySrc, int widthSrc, int heightSrc, BYTE alpha);
	BOOL	Draw32(CBm32 &bm32, int xDst, int yDst, int xSrc = 0, int ySrc = 0,
						int width = 0, int height = 0, BYTE alpha = 255);
	BOOL	DrawAddAlpha(CBm32 &bm32, int xDst, int yDst,
						int xSrc, int ySrc, int width, int height, BYTE alpha, BOOL bMinus = 0);
	BOOL	DrawColor(BYTE alpha, BYTE red, BYTE green, BYTE blue,
						int x = 0, int y = 0, int width = 0, int height = 0);
	BOOL	AddColor(BYTE red, BYTE green, BYTE blue, 
						int x = 0, int y = 0, int width = 0, int height = 0, BOOL bMinus = 0);
	BOOL	ChangeAlpha(BYTE alpha, int x = 0, int y = 0, int width = 0, int height = 0);
	BOOL	Monotone(int x = 0, int y = 0, int width = 0, int height = 0);
	BOOL	Hue(int hue, int x = 0, int y = 0, int width = 0, int height = 0);
	BOOL	DrawFont(TCHAR *str, int size, int x, int y, BYTE red, BYTE green, BYTE blue);
	BOOL	DrawFontDC(HDC hDC, TCHAR *str, int size, int x, int y, BYTE red, BYTE green, BYTE blue);
	~CBm32();
	
private:
	HBITMAP	CreateSub(int width, int height);
	RECT	Clip32(int x, int y, int width, int height, int wdhDib, int hgtDib);
	
private:
	HBITMAP	m_hBmp;						// rbg}bvnh
	TCHAR	m_strFilename[MAX_PATH];	// 摜t@C
	BOOL	m_bColorkey;				// J[L[tO
	UINT	m_nColorkey;				// J[L[
	int		m_nWidth;					// 摜
	int		m_nHeight;					// 摜
	int		m_nBPP;						// F[x
	PBYTE	m_pBits;					// 摜̃sNZl
};

class DECLSPEC CFont32
{
public:
	CFont32();
	void	Set(TCHAR *strFontName, int iWeight, int iCharSet, int iPitchAndFamily, int iQuality,
				BYTE bItalic = 0, BYTE bUnderline = 0, BYTE bStrikeOut = 0);
	~CFont32();
};

#endif
